//+------------------------------------------------------------------+
//|                                                      ickBars.mq4 |
//|                                      Copyright  2010, IgorM     |
//|                               http://www.mql4.com/ru/users/IgorM |
//+------------------------------------------------------------------+
#property copyright "IgorM"
#property link      "http://www.mql4.com/ru/users/IgorM"

#include <WinUser32.mqh>

extern int		NumTF	= 1;
extern int		TicksInBar	= 60;

int HistoryHandle = -1, HistoryFilePos = 0, hwnd = 0,now_time,tb;
double now_close, now_open, now_low, now_high, now_volume,bid;
string _Symbol,win_name;

//_____________________________________________________
int init(){
   tb = TicksInBar;
   _Symbol = Symbol();
   win_name = StringConcatenate( "!bar", _Symbol );
	hwnd = 0;
	string file_name = StringConcatenate( "!bar", _Symbol, NumTF, ".hst" );
	HistoryHandle = FileOpenHistory( file_name, FILE_BIN|FILE_READ);
	if ( HistoryHandle < 0 ){
		 HistoryHandle = FileOpenHistory( file_name, FILE_BIN|FILE_WRITE );
		 if ( HistoryHandle < 0 ) Print( "    ", file_name,"- Error #", GetLastError());
		   else{ 
		        Print(" ", file_name,"  ,   ");
		        FileWriteInteger( HistoryHandle, 400, LONG_VALUE );
	           FileWriteString( HistoryHandle, "Copyright  2010, IgorM", 64 );
	           FileWriteString( HistoryHandle, StringConcatenate( "!bar", _Symbol ), 12 );
	           FileWriteInteger( HistoryHandle, NumTF, LONG_VALUE );
	           FileWriteInteger( HistoryHandle, Digits, LONG_VALUE );
	           now_time		= TimeCurrent();
	           FileWriteInteger( HistoryHandle, now_time, LONG_VALUE );
	           FileWriteInteger( HistoryHandle, now_time, LONG_VALUE );
	           int temp[13];
	           FileWriteArray( HistoryHandle, temp, 0, 13 );
	           FileFlush(HistoryHandle);
	      }
   } else Print(" ", file_name," , ");
	FileClose(HistoryHandle);
	HistoryHandle = FileOpenHistory( file_name, FILE_BIN|FILE_READ|FILE_WRITE);
	if ( HistoryHandle < 0 ){Alert("     ", file_name,"- Error #", GetLastError());	return(-1);}
	FileSeek(HistoryHandle, 0, SEEK_END);
	now_time		= TimeCurrent();
	now_volume	= 0;
	now_close	= iClose(Symbol(),0,0);
	now_open		= now_close;
	now_low		= now_close;
	now_high		= now_close;
	HistoryFilePos = FileTell( HistoryHandle);
return(0);
}
//_____________________________________________________
int deinit(){
	if ( HistoryHandle > 0 ){FileClose( HistoryHandle );HistoryHandle = -1;}
return(0);
}
//_____________________________________________________
int start(){
	if ( HistoryHandle < 0 ) return(-1);
	FileSeek( HistoryHandle, HistoryFilePos, SEEK_SET );
	now_volume ++;
//------    	
	bid = MathSin(Bid)+MathPow(MathCos(Bid),2);
	tb = TicksInBar + MathRand()/1000;
//--------------------------------------	
	if ( now_volume <= tb ){
		if ( bid < now_low  ) now_low  = bid;
		if ( bid > now_high ) now_high = bid;
		now_close = bid;
		writehistory();
	} else {
	       writehistory(1);
		    now_time = TimeCurrent();
		    now_open = bid;
		    now_low	 = bid;
		    now_high = bid;
	  	    now_close= bid;
		    now_volume	= 1;
		    HistoryFilePos = FileTell( HistoryHandle);
		    writehistory();
	}
return(0);
}
//_____________________________________________________
void writehistory(int shift=0){
      FileWriteInteger	( HistoryHandle, now_time,		LONG_VALUE	);
		FileWriteDouble	( HistoryHandle, now_open,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_low,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_high,		DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_close,	DOUBLE_VALUE);
		FileWriteDouble	( HistoryHandle, now_volume-shift,	DOUBLE_VALUE);
		FileFlush			( HistoryHandle );
return;
}



